<?php
 
Header("Content-type: image/png");
drawRatingBlocks(0);
 
function drawRatingBlocks($rating) {
     $rating = $_GET['rating'];
     $width = 115;
     $height = 15;
     $blocks = 10;
 
    if ($width == 0) $width = 130;
     if ($height == 0) $height = 13;
 
    $spacing = max(1, floor($height/6) );
 
    if ($blocks == 0) $blocks = floor( $width / ($height-2 + $spacing) );
 
    $blockwidth = floor( $width / $blocks ) - $spacing;
     $short_side = min($height-2, $blockwidth);
     $blockvalue = 100 / $blocks;
    
    $image = ImageCreateTrueColor($width,$height);
    $img2  = ImageCreateTrueColor($width,$height);
 
    imagealphablending($image,false);
    imagealphablending($img2,false);

    // Define base colors
    $back = ImageColorAllocatealpha($image,128,128,255,127);
    $blur = ImageColorAllocate($image,220,229,236);
    //$fill = ImageColorAllocate($image,255,0,0);
    $fill = ImageColorAllocate($image,143,168,193);     
    
    // light colors are calculated automatically
    $color     = imagecolorsforindex($image, $blur);
    $lightblur = ImageColorAllocatealpha($image,$color['red'],$color['green'],$color['blue'],64); 
    $color     = imagecolorsforindex($image, $fill);
    $lightfill = ImageColorAllocatealpha($image,$color['red'],$color['green'],$color['blue'],64); 
    ImagePaletteCopy($img2,$image);
 
    ImageFilledRectangle($image,0,0,$width-1,$height-1,$back);
    ImageFilledRectangle($img2,0,0,$width-1,$height-1,$back);
    
    imagealphablending($image,true);
    imagealphablending($img2,true);
     
    if ($short_side < 25)
         $radius = 1;
     else if ($short_side < 40)
         $radius = 3;
     else if ($short_side < 50)
         $radius = 5;
     else
         $radius = floor($height/10);
 
    for($i=0;$i<$blocks;$i++) {
         $startX = ($blockwidth+$spacing)*$i + 1;
         if ((9 <= $short_side) && ($short_side <= 16)) 
        {
             ImageFilledRectangle($image, $startX, 1, $startX+$blockwidth-1, $height-2, $lightblur);
             ImageFilledRectangle($img2, $startX, 1, $startX+$blockwidth-1, $height-2, $lightfill);
         }
         ImageRectangleWithRoundedCorners($image, $startX, 1, $startX+$blockwidth-1, $height-2, $radius, $blur);
         ImageRectangleWithRoundedCorners($img2, $startX, 1, $startX+$blockwidth-1, $height-2, $radius, $fill);
     }
 
    $barwidth = ($rating/100)*$blocks*$blockwidth;
    $barwidth += floor($barwidth/$blockwidth)*$spacing+1;
 
    ImageCopy( $image, $img2, 0, 0, 0, 0, $barwidth, $height );
    imagealphablending($image,true);

    ImageDestroy($img2);

    imagesavealpha($image,true);
    ImagePNG($image);
    ImageDestroy($image);
 }
 
function ImageRectangleWithRoundedCorners(&$im, $x1, $y1, $x2, $y2, $radius, $color)
 {
     // Draw rectangle without corners
     ImageFilledRectangle($im, $x1+$radius, $y1, $x2-$radius, $y2, $color);
     ImageFilledRectangle($im, $x1, $y1+$radius, $x2, $y2-$radius, $color);
     // Draw circled corners
     ImageFilledEllipse($im, $x1+$radius, $y1+$radius, $radius*2, $radius*2, $color);
     ImageFilledEllipse($im, $x2-$radius, $y1+$radius, $radius*2, $radius*2, $color);
     ImageFilledEllipse($im, $x1+$radius, $y2-$radius, $radius*2, $radius*2, $color);
     ImageFilledEllipse($im, $x2-$radius, $y2-$radius, $radius*2, $radius*2, $color);
 }
?>
