<?php  
session_start();
$_SESSION['s_inuse'] = 1;
$footer_text = "Copyright 2000-2010 RaidenFTPD team. All Rights Reserved.";
$rlaversion = '1.1 build.8 (2013/04/08)'; 

function getFileType($string)
{
    $type = pathinfo($string, PATHINFO_EXTENSION);
	return $type;
}

function rlalog ($user,$message)
{
    $time =  date("Y/m/d H:i:s");
    $fp = fopen("rlalog.log","a+");
    $outstring = $time . "|" . trim($user) . "|" . session_id() . "|" . trim($message) . "\n";
	fwrite($fp, $outstring);
	fclose($fp);
}

function isPrivateIP($ip)
{
	$arr = explode(".",$ip);
	if(count($arr) != 4)
		return false;
	if($arr[0] == 10)
		return true;
	if($arr[0] == 192 && $arr[1] == 168)
		return true;
	if($arr[0] == 172 && ($arr[1] >= 16 && $arr[1] <= 31))
		return true;
	return false;
}

function isFilenameSecure($filename)
{
	if(strstr($filename, '..') != false || strstr($filename, ':') != false || strstr($filename, '"') != false || strstr($filename, "'") != false || strstr($filename, "?") != false || strstr($filename, "*") != false)
		return false;
	else
		return true;
}

function csv_explode($delim=',',$str, $enclose='"',$preserve=false)
{
  $resArr = array();
  $n = 0;
  $expEncArr = explode($enclose, $str);
  foreach($expEncArr as $EncItem)
  {
    if($n++%2)
      array_push($resArr, array_pop($resArr) . ($preserve?$enclose:'') . $EncItem.($preserve?$enclose:''));
    else
    {
      $expDelArr = explode($delim, $EncItem);
      array_push($resArr, array_pop($resArr) . array_shift($expDelArr));
      $resArr = array_merge($resArr, $expDelArr);
    }
  }
  return $resArr;
}

function clear_timestamp($inputts)
{
    $return_str = substr($inputts,0,10) . " " . substr($inputts,11,8);
    return $return_str;
}

function pattern_to_preg($filtermask)
{
    $outmask = "";
    $array = explode("|",$filtermask);     
    foreach ($array as $item => $val) {
        $val = preg_quote($val);
        $val = str_replace("\\*",".*",$val);
        if ($outmask == "") { $outmask = $val; }
        else { $outmask = $outmask . "|" . $val; }
    }
    return "#.*(?i:" . $outmask . ").*#";
}

function byte_format($input, $dec=2)
{
    $prefix_arr = array(" B", " KB", " MB", " GB", " TB", "PB");
	$value = round($input, $dec);
	$i=0;
	while ($value > 1024)
	{
        $value /= 1024;
		$i++;  
    }
    
    $format = "%01." . $dec ."f";
    $return_str = sprintf($format, round($value, $dec)) . $prefix_arr[$i];
	return $return_str;
}

function kbs_format($input, $dec=2)
{
    $prefix_arr = array(" Kb/s", " Mb/s", " Gb/s", " Tb/s", "Pb/s");
    $value = round($input, $dec);
    $i=0;
    while ($value > 1000)
    {
        $value /= 1000;
        $i++;  
    }
    $format = "%01." . $dec ."f";
    $return_str = sprintf($format, round($value, $dec)) . $prefix_arr[$i];
    return $return_str;
}

function second_format($input, $dec=2)
{
    $prefix_arr = array(" s", " ms", " µs");
    $value = $input;
    $testvalue = round($value,3);
    $i=0;
    while ($testvalue < 1)
    {
        $value *= 1000;
        $testvalue = round($value,3);
        $i++;  
    }
    $format = "%01." . $dec ."f";
    $return_str = sprintf($format, round($value, $dec)) . $prefix_arr[$i];
    return $return_str;
}

function strposOffset($search, $string, $offset)
{
    /*** explode the string ***/
    $arr = explode($search, $string);
    /*** check the search is not out of bounds ***/
    switch( $offset )
    {
        case $offset == 0:
        return false;
        break;
    
        case $offset > max(array_keys($arr)):
        return false;
        break;

        default:
        return strlen(implode($search, array_slice($arr, 0, $offset)));
    }
}

function samepaths($path1, $path2, $list)
{
    $dirpath1 = dirname($path1);
    $dirpath2 = dirname($path2);
    
    $regmask = "#.\/(?i:" . $list . ")#"; 
    
    while(preg_match($regmask, $dirpath1))
    { $dirpath1 = dirname($dirpath1); }

    while(preg_match($regmask, $dirpath2))
    { $dirpath2 = dirname($dirpath2); }
  
     if ($dirpath1 == $dirpath2) {return true;}
     else {return false;}
}

function basepath($path,$list)
{
    $dirpath = dirname($path);
     
    $regmask = "#.\/(?i:" . $list . ")#"; 
    
    while(preg_match($regmask, $dirpath))
    { 
        $dirpath = dirname($dirpath); 
    }
  
     return $dirpath;
}

function pagination_link($id, $page_num)
{
    if ($id == "rawlogquery") {
        return 'onclick="javascript:submitRawQuery('. $page_num .')" onmouseover="" style="cursor: pointer; text-decoration:underline;"';
    }
    else {
        $refererlink = $_SERVER['HTTP_REFERER'];
        
        $mask = "#&page\=[0-9]+#";
        $refererlink = preg_replace($mask,"",$refererlink);
        
        return 'href="' . $refererlink .'&page='. $page_num . '"' ;
    }
}

function pagination($num_of_items, $items_per_page, $id, $page_num)
{
    
    $max_links = 9;
    $total_pages = ceil($num_of_items/$items_per_page);
    $out = '';
    
    if (isset($page_num)) {}
    else { $page_num = 1; }
   
    if($page_num) {
        if($page_num > 1){ 
            $firstpage = '<a '.pagination_link($id, (1)).'>1</a>';
        }
    }
    if($page_num <$total_pages){ 
        $lastpage = '&nbsp;<a '.pagination_link($id, $total_pages).'>'.$total_pages.'</a>&nbsp;';
    }
    
    if($page_num >= 5) {
        $page_counter = ceil($page_num - 4);
        if($page_num >= $total_pages - 4) {
            $page_counter = $total_pages - 8; 
            if ($page_counter < 1) {
               $page_counter = 1; 
            }   
        }
    } else {
        $page_counter = 1;
    }
    if($total_pages < $max_links){
        $max_links = $total_pages;
    }
    
    //Process
    if ($total_pages > 1) {  
        $loop = 0;
        if($page_num > 1){
            if(($page_num > 5) && ($total_pages > 9)){
                $out .= $firstpage;
                $out .= '&nbsp; &lt; &nbsp;'; 
            }
        }
        do{ 
            if($page_counter == $page_num) {
                $out .= '<strong>' .$page_counter.'</strong> &nbsp; '; 
            } else {
                $out .= '<a '.pagination_link($id, ($page_counter)).'>'.$page_counter.'</a> &nbsp; ';
            } 
            $page_counter++; $current_page=($page_counter+1);
            $loop++;
        } while ($max_links > $loop);

        if($page_num <= $total_pages - 5){
            if($total_pages > $max_links) {
                $out .= ' &gt; ';  
                $out .= $lastpage;
            }
        }
    }
    return $out;
}   

// ARRAY map REQUIRED FUNCTIONS
function col_0 ($n) { return($n[0]); }
function col_1 ($n) { return($n[1]); }
function col_2 ($n) { return($n[2]); }
function col_3 ($n) { return($n[3]); }
function col_4 ($n) { return($n[4]); }
function col_5 ($n) { return($n[5]); }
function col_6 ($n) { return($n[6]); }
function col_7 ($n) { return($n[7]); }
function col_8 ($n) { return($n[8]); }
function col_9 ($n) { return($n[9]); }
function col_10 ($n) { return($n[10]); }
function col_11 ($n) { return($n[11]); }
?>